/*
 * libsgml -- SGML state machine parsing library.
 *                                                                  
 * Copyright (c) 2002 Uninformed Research (http://www.uninformed.org)
 * All rights reserved.
 *
 * skape
 * mmiller@hick.org
 */
#ifndef _LIBSGML_HTMLNODELIST_H
#define _LIBSGML_HTMLNODELIST_H

#include "HtmlNode.h"

typedef struct _html_node_list_node {

	HTML_NODE                   *node;

	struct _html_node_list_node *next;

} HTML_NODE_LIST_NODE;

typedef struct _html_node_list {

	struct _html_node_list_node *firstNode;
	struct _html_node_list_node *lastNode;

	unsigned long               entries;

} HTML_NODE_LIST;

HTML_NODE_LIST *htmlNodeListNew();
void htmlNodeListDestroy(HTML_NODE_LIST *nodeList);

void htmlNodeListAddNode(HTML_NODE_LIST *nodeList, HTML_NODE *node);
void htmlNodeListRemoveNode(HTML_NODE_LIST *nodeList, HTML_NODE *node);

unsigned long htmlNodeListGetNumEntries(HTML_NODE_LIST *nodeList);
HTML_NODE_LIST_NODE *htmlNodeListGetFirstNode(HTML_NODE_LIST *nodeList);

#endif
